unit Unit23;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls;

type
  TForm23 = class(TForm)
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Image1: TImage;
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MainImageMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  private
   m_moving: boolean;
   m_moveStart: TPoint;
   MouseDownX, MouseDownY: integer;
   fupdating: boolean;
  public
  end;

var
  Form23: TForm23;

implementation

{$R *.dfm}


procedure TForm23.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 m_moving := false;
end;

procedure TForm23.MainImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
begin
 if m_moving then
 begin
  m_moveStart := Point(x,y);
  paintbox1.Invalidate;
 end;
end;


procedure TForm23.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 MouseDownX:= X;
 MouseDownY:= Y;
 m_moveStart:= Point(X, Y);

 if ssLeft in Shift then
 begin
  m_moving := true;
 end;
end;

procedure TForm23.PaintBox1Paint(Sender: TObject);
var
 newrext: TRect;
begin
 newrext.Left:= MouseDownX - m_moveStart.X;
 newrext.top:= MouseDownY - m_moveStart.Y;
 newrext.Right:= newrext.Left + (paintbox1.ClientRect.Right - paintbox1.ClientRect.Left);
 newrext.bottom:= newrext.Top + (paintbox1.ClientRect.bottom - paintbox1.ClientRect.Top);

 Paintbox1.Canvas.CopyRect(paintbox1.ClientRect, Image1.Picture.Bitmap.Canvas, newrext);
 Paintbox1.Font.Color:= clRed;
 Paintbox1.Font.Size:= 12;
 Paintbox1.Canvas.TextOut(10, 10, datetimetostr(now));
end;


end.
